# Gio::UnixConnection Class Reference
[Portable Network I/O Functionality]

A Unix domain SocketConnection. More...

`#include <giomm/unixconnection.h>`

Inheritance diagram for Gio::UnixConnection:
[legend]

List of all members.

## Public Member Functions

virtual | ~UnixConnection ()
GUnixConnection* | gobj ()
| Provides access to the underlying C GObject.
const GUnixConnection* | gobj () const
| Provides access to the underlying C GObject.
GUnixConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | send_fd (int fd, const Glib::RefPtr< Cancellable >& cancellable)
| Passes a file descriptor to the recieving side of the connection.
int | receive_fd (const Glib::RefPtr< Cancellable >& cancellable)
| Receives a file descriptor from the sending end of the connection.

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixConnection > | wrap (GUnixConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A Unix domain SocketConnection.

This is the subclass of SocketConnection that is created for UNIX domain sockets.

It contains functions to do some of the unix socket specific functionallity like passing file descriptors.

Since glibmm 2.24:

## Constructor & Destructor Documentation

virtual Gio::UnixConnection::~UnixConnection | ( |  | ) | `[virtual]`

## Member Function Documentation

const GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketConnection.

GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketConnection.

GUnixConnection* Gio::UnixConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::SocketConnection.

int Gio::UnixConnection::receive_fd | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Receives a file descriptor from the sending end of the connection.

The sending end has to call g_unix_connection_send_fd() for this to work.

As well as reading the fd this also reads a single byte from the stream, as this is required for fd passing to work on some implementations.

Parameters:

  | cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A file descriptor on success, -1 on error.

Since glibmm 2.22:

bool Gio::UnixConnection::send_fd | ( | int | fd,
|  | const Glib::RefPtr< Cancellable >& | cancellable |
| ) |  |  |

Passes a file descriptor to the recieving side of the connection.

The recieving end has to call g_unix_connection_receive_fd() to accept the file descriptor.

As well as sending the fd this also writes a single byte to the stream, as this is required for fd passing to work on some implementations.

Parameters:

  | fd | A file descriptor.
  | cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A `true` on success, `0` on error.

Since glibmm 2.22:

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixConnection > wrap | ( | GUnixConnection * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.